From b6a5f67b193f861dc89cb874bbdcb8d96118a722 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Apr 17 2020 23:44:03 +0000
Subject: [PATCH 287/2232] Remove methods from intro example code


I'd like to keep this first code snippet as focused as possible on the
most important concepts. We'll need to figure out somewhere else to put
exhaustive documentation of the full feature set.

---

diff --git a/demo-cxx/demo.cc b/demo-cxx/demo.cc
index bc0d976..cd447ea 100644
--- a/demo-cxx/demo.cc
+++ b/demo-cxx/demo.cc
@@ -9,19 +9,13 @@ ThingC::ThingC(std::string appname) : appname(std::move(appname)) {}
 
 ThingC::~ThingC() { std::cout << "done with ThingC" << std::endl; }
 
-const std::string &ThingC::get_name() const {
-  std::cout << "I'm a C++ method!" << std::endl;
-  return this->appname;
-}
-
 std::unique_ptr<ThingC> make_demo(rust::Str appname) {
   return std::unique_ptr<ThingC>(new ThingC(std::string(appname)));
 }
 
-void do_thing(SharedThing state) {
-  print_r(*state.y);
-  state.y->print();
-}
+const std::string &get_name(const ThingC &thing) { return thing.appname; }
+
+void do_thing(SharedThing state) { print_r(*state.y); }
 
 } // namespace example
 } // namespace org
diff --git a/demo-cxx/demo.h b/demo-cxx/demo.h
index 885293f..fafc474 100644
--- a/demo-cxx/demo.h
+++ b/demo-cxx/demo.h
@@ -12,13 +12,12 @@ public:
   ~ThingC();
 
   std::string appname;
-
-  const std::string &get_name() const;
 };
 
 struct SharedThing;
 
 std::unique_ptr<ThingC> make_demo(rust::Str appname);
+const std::string &get_name(const ThingC &thing);
 void do_thing(SharedThing state);
 
 } // namespace example
diff --git a/demo-rs/src/main.rs b/demo-rs/src/main.rs
index 713a1d1..66dfc79 100644
--- a/demo-rs/src/main.rs
+++ b/demo-rs/src/main.rs
@@ -11,15 +11,13 @@ mod ffi {
 
         type ThingC;
         fn make_demo(appname: &str) -> UniquePtr<ThingC>;
-        fn get_name(self: &ThingC) -> &CxxString;
+        fn get_name(thing: &ThingC) -> &CxxString;
         fn do_thing(state: SharedThing);
-
     }
 
     extern "Rust" {
         type ThingR;
         fn print_r(r: &ThingR);
-        fn print(self: &ThingR);
     }
 }
 
@@ -29,15 +27,9 @@ fn print_r(r: &ThingR) {
     println!("called back with r={}", r.0);
 }
 
-impl ThingR {
-    fn print(&self) {
-        println!("method called back with r={}", self.0);
-    }
-}
-
 fn main() {
     let x = ffi::make_demo("demo of cxx::bridge");
-    println!("this is a {}", x.as_ref().unwrap().get_name());
+    println!("this is a {}", ffi::get_name(x.as_ref().unwrap()));
 
     ffi::do_thing(ffi::SharedThing {
         z: 222,
diff --git a/src/lib.rs b/src/lib.rs
index 780a26e..609db59 100644
--- a/src/lib.rs
+++ b/src/lib.rs
@@ -79,10 +79,8 @@
 //!
 //!         // Functions implemented in C++.
 //!         fn make_demo(appname: &str) -> UniquePtr<ThingC>;
+//!         fn get_name(thing: &ThingC) -> &CxxString;
 //!         fn do_thing(state: SharedThing);
-//!
-//!         // Methods implemented in C++.
-//!         fn get_name(self: &ThingC) -> &CxxString;
 //!     }
 //!
 //!     extern "Rust" {
@@ -92,9 +90,6 @@
 //!
 //!         // Functions implemented in Rust.
 //!         fn print_r(r: &ThingR);
-//!
-//!         // Methods implemented in Rust.
-//!         fn print(self: &ThingR);
 //!     }
 //! }
 //! #
@@ -104,12 +99,6 @@
 //! #     println!("called back with r={}", r.0);
 //! # }
 //! #
-//! # impl ThingR {
-//! #     fn print(&self) {
-//! #         println!("method called back with r={}", self.0);
-//! #     }
-//! # }
-//! #
 //! # fn main() {}
 //! ```
 //!

